﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.01
@EndOfDesignText@
'version: 1.0
#Event: ItemClick (Index As Int, Value As Int)
Sub Class_Globals
	Private sv As ScrollView
	Private items As List
	Private panels As List
	Private pressedDrawable As Object
	Private EventName As String
	Private CallBack As Object
	Public DefaultTextSize As Int
	Public DefaultTextColor As Int
	Public DefaultTextBackgroundColor As Int
End Sub

Public Sub NewColor(nColor As Int)
	sv.Color =nColor
	DefaultTextBackgroundColor = nColor
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	sv.Initialize2(0, "sv")
	items.Initialize
	panels.Initialize
	EventName = vEventName
	CallBack = vCallback
	sv.Color =0xFFA2B3D4
	Dim r As Reflector
	Dim idPressed As Int
	idPressed = r.GetStaticField("android.R$drawable", "list_selector_background")
	r.Target = r.GetContext
	r.Target = r.RunMethod("getResources")
	pressedDrawable = r.RunMethod2("getDrawable", idPressed, "java.lang.int")
	DefaultTextColor = Colors.White
	DefaultTextSize = B4XPages.MainPage.TextSize
	DefaultTextBackgroundColor = Colors.Black 
End Sub

'Returns a view object that holds the list.
Public Sub AsView As View
	Return sv
End Sub

Public Sub Clear
	items.Clear
	panels.Clear
	sv.Panel.Height = 0
	For i = sv.Panel.NumberOfViews - 1 To 0 Step -1
		sv.Panel.RemoveViewAt(i)
	Next
End Sub
'Returns the value stored at the specified index.
Public Sub GetValue(Index As Int) As Object
	Return items.Get(Index)
End Sub


Public Sub InsertAt(Index As Int, Pnl As Panel, ItemHeight As Int, Value As Object,Diver As Float,Ena As Boolean)
    
	Dim sd As StateListDrawable
	sd.Initialize
	sd.AddState(sd.State_Pressed, pressedDrawable)
	sd.AddCatchAllState(Pnl.Background)
	
	'create another panel to handle the click event
	Dim p As Panel
	p.Initialize("panel")
	p.Background = sd
	If Ena=False Then
		p.Enabled=False
	Else
		p.Enabled=True	
	End If
	Dim cd As ColorDrawable
	cd.Initialize(0xFFF2F2F2, 0)
	Pnl.Background = cd
	p.AddView(Pnl, 0, 0, sv.Width, ItemHeight)
	p.Tag = Index
	
	If Index = items.Size Then
		items.Add(Value)
		panels.Add(p)
		Dim top As Int
		If Index = 0 Then top = Diver Else top = sv.Panel.Height
		sv.Panel.AddView(p, 0, top, sv.Width, ItemHeight)
	Else
		Dim top As Int
		If Index = 0 Then
			top = Diver
		Else
			Dim previousPanel As Panel
			previousPanel = panels.Get(Index - 1)
			top = previousPanel.top + previousPanel.Height + Diver
		End If

		Dim p2 As Panel
		For i = Index To panels.Size - 1
			p2 = panels.Get(i)
			p2.top = p2.top + ItemHeight + Diver
			p2.Tag = i + 1
		Next
		items.InsertAt(Index, Value)
		panels.InsertAt(Index, p)
		sv.Panel.AddView(p, 0, top, sv.Width, ItemHeight)
	End If
	sv.Panel.Height = sv.Panel.Height + ItemHeight + Diver
	If items.Size = 1 Then sv.Panel.Height = sv.Panel.Height + Diver
End Sub

'Adds a custom item.
Public Sub Add(Pnl As Panel, ItemHeight As Int, Value As Object,Diver As Float,Ena As Boolean)
	InsertAt(items.Size, Pnl, ItemHeight, Value,Diver,Ena)
End Sub

Private Sub Panel_Click
	If SubExists(CallBack, EventName & "_ItemClick") Then
		Dim v As View
		v = Sender
		CallSub3(CallBack, EventName & "_ItemClick", v.Tag, items.Get(v.Tag))
	End If
End Sub


'Set the new value at the specified index.
Public Sub SetValue(Index As Int, NewValue As Object )' As Boolean
'	Try
	items.Set (Index, NewValue)
'		Return True
'	Catch
'		Return False
'	End Try
End Sub

'Returns the number of items.
Public Sub GetSize As Int
	Return items.Size
End Sub

'Returns the Panel stored at the specified index.
Public Sub GetPanel(Index As Int) As Panel
	Dim p As Panel
	p = panels.Get(Index) 'this is the parent panel
	Return p.GetView(0)
End Sub

